      SUBROUTINE CCHART
C     VAX VERSION SEPARATED FROM POWDC
C     LINKS WITH POWD_12 AND GRAPH2 USING POWD_12.COM
C
C     VERSION OF 30 NOV 1985
C     3 JAN 1986 ASCII FILE OUTPUT
C     29 MAR 1986
C     19 JULY 1986 PROFILE CHANGES
C     25 SEPT 1986
C     3 OCT 1986 SCHERRER BROADENING COMPLETED
C     22 MAR 1988 '.CMB'
C
C
C
C     THIS VERSION OF CCHART PRODUCES AN ADDITIONAL OUTPUT IN A FORMAT
C     FOR DIRECT TYPING OF JCPDS CARDS.  IT IS  ROUTINELY USED AT PSU
C     FOR THE PRODUCTION OF REFERENCE PATTERNS.  AFTER FILLING IN THE
C     APPROPRIATE SPACES THE OUTPUT MAY BE SUBMITTED DIRECTLY TO THE  
C     JCPDS FOR INCLUSION IN THE PDF.
C
C     PROGRAM TO SIMULATE A DIFFRACTOMETER CHART 
C     *** PSU PRODUCTION VERSION ***  
C
      INTEGER*2 IH,IK,IL,IY(8001)
      CHARACTER*1 NQUES
      LOGICAL*1 FMT(56),FMT1(56),FMT2(48),ITITLE,IDAY 
      REAL*8 AFMT(7),AFMT1(7),AFMT2(6)   
      EQUIVALENCE (FMT(1),AFMT(1)),(FMT1(1),AFMT1(1)),(FMT2(1),AFMT2(1))
      EQUIVALENCE (HEADER,ITITLE(1)),(TITLE,ITITLE(1))
      CHARACTER*12 FILNAM
      CHARACTER*18 HEADER,FILEX
      CHARACTER*40 TITLE
      CHARACTER*39 TITLE1
      DATA AFMT(1),AFMT(2),AFMT(3),AFMT(4),AFMT(5),AFMT(6),AFMT(7)/
     +'(1X,F8.4',',1X,I4,1','X,2(3I3,','A1),2X,F','8.4,1X,I', 
     +'4,1X,2(3','I3,A1)) '/   
      DATA AFMT1(1),AFMT1(2),AFMT1(3),AFMT1(4),AFMT1(5),AFMT1(6),
     +AFMT1(7)/  '(1X,F8.4',',1X,I4,1','X,3I3,13','X,F8.4,1',
     +'X,I4,1X,','2(3I3,A1','))      '/  
      DATA AFMT2(1),AFMT2(2),AFMT2(3),AFMT2(4),AFMT2(5),AFMT2(6)/ 
     +'(/1X,F8.','4,1H,,F8','.4,1H,,F','8.4,10X,','2(I3,1H,', 
     +'),I3)   '/      
      LOGICAL*1 ONE/'1'/,TWO/'2'/,THREE/'3'/,FOUR/'4'/,SEVEN/'7'/, 
     1EIGHT/'8'/ 
      COMMON/GENL/WL1,WL2,DMIN,XMUR,XMAX,XMU,A(19),SC(5),
     1ITIME,NIN,NOUT,NPUNCH,NSCRT1,NFILE,IA,NABS,NSG,IXYZ,ITRANS,
     2NTRANS(3,3),ISCALE,NPLOT,NREFL,NAS,NWL,ISH,ISK,ISL,IOUT,LENT,
     3 LENX,ITITLE(320),IDAY(8)
      COMMON/DATA/D(1001),IH(1001),IK(1001),IL(1001) 
      COMMON/CAL/XINT1(1000),XINT3(1000),TTH1(1000)
      COMMON /XPLOT/W,TTHETA,SCMAX 
      COMMON/CELLS/REALA,B,C,ALPHA,BETA,GAMMA,DUMMY(14)
      COMMON /DENSTY/ DENS,DENSC 
      COMMON /IICOR/ XINTR
      COMMON /PRINT/ NPOPT1,NPOPT2,NPOPT3,NPOPT4,NPOPT5,NPOPT6,
     *NPOPT7,NPOPT8,NPOPT9,NPOPT0
      DIMENSION XINT2(1000),TTH2(1000)
      DIMENSION Y(8001),YR(8001),R(2001)
      DIMENSION TABLE1(15),TABLE2(15),TABLE(15),XANGLE(15) 
      DIMENSION TABLE3(15),TABLE4(15),TABLE5(15),TABLE6(15),
     *TABLE7(15),TABLE8(15),TABLE9(15),TABLE0(15),
     *TAB4(14),TAB5(14),TAB6(14),TAB7(14),ANGLE2(14)
      DIMENSION TEM(20),ITEM(20)  
      DIMENSION CELL(6) 
      DATA BLANK,PLUS,SIGN1,SIGN2,COMMA/' ','+',' ',' ',','/
      DATA TAB4 /0.0200,0.0175,0.0146,0.0122,0.0104,0.0092,0.0093,
     *0.0108,0.0138,0.0184,0.0241,0.0303,0.0365,0.0700/
      DATA TAB5 /0.0241,0.0202,0.0165,0.0132,0.0107,0.0091,0.0090,
     *0.0102,0.0125,0.0159,0.0205,0.0252,0.0300,0.0500/
      DATA TAB6 /1.00,1.00,1.29,1.45,1.59,1.70,1.77,1.84,1.87,1.90,
     *1.91,1.92,1.93,2.00/
      DATA TAB7 /2.225,2.215,2.200,2.180,2.150,2.100,2.030,1.940,
     *1.850,1.730,1.560,1.370,1.150,1.000/
      DATA ANGLE2 /0.0,10.0,20.0,30.0,40.0,50.0,60.0,70.0,80.0,
     *90.0,100.0,110.0,120.0,165.0/
C
C     INITIALIZE VARIABLES
C
      PI=3.141593 
      SQRTPI=1.77245385
      RAD=114.5916 
      CFRAC=1.0
      ZERO=0.0
      SANGLE=5.00 
      UANGLE=165.00 
      RESET=249.00
      NTAPE1=10 
      NTAPE2=11
      OPEN(UNIT=NTAPE1,STATUS='SCRATCH')
      OPEN(UNIT=NTAPE2,STATUS='SCRATCH')
      KOUNT=0   
      KOUNT2=0 
      EXPON1=1.0
      EXPON2=1.0
      FACT=2.0/RAD   
      TITLE1='CALCULATED PATTERN FROM POWD12         '
      ALPHA=(ACOS(ALPHA))/FACT
C     ARCOS REPLACED WITH ACOS GGJJ 4/25/85
      BETA=(ACOS(BETA))/FACT 
C     ARCOS REPLACED WITH ACOS GGJJ 4/25/85
      GAMMA=(ACOS(GAMMA))/FACT
C     ARCOS REPLACED WITH ACOS GGJJ 4/25/85
C
C     OLD NBS MEASURED SILICON
      DATA TABLE1/0.060,0.066,0.075,0.089,0.108,0.130,0.160,0.175,0.205,
     10.225,0.250,0.295,0.360,0.410,0.500/
C 
C     OLD NBS MEASURED ALUMINA WITH BROADENING
      DATA TABLE2/0.070,0.075,0.088,0.105,0.130,0.185,0.260,0.315,0.390,
     10.450,0.535,0.750,1.200,1.500,2.000/
C
C     NBS MEASURED FWHM TABLE
      DATA TABLE3/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
C     TABLE FOR PSU PHILIPS
      DATA TABLE4/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
C     TABLE FOR PSU SCINTAG
      DATA TABLE5/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
C     DATA FOR GMRL SIEMENS
      DATA TABLE6/0.17,0.15,0.13,0.13,0.14,0.14,0.16,0.20,0.23,
     *0.25,0.27,0.29,0.31,0.32,0.33/ 
C
C     TABLE FOR RIGAKU
      DATA TABLE7/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
C     TABLE FOR NICOLET
      DATA TABLE8/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
C     TABLE FOR SYNCHROTRON
      DATA TABLE9/0.03,0.03,0.03,0.032,0.035,0.038,0.041,0.045,0.050,
     *0.055,0.060,0.070,0.080,0.090,0.100/ 
C
C     TABLE ENTERED BY USER
      DATA TABLE0/0.12,0.12,0.12,0.125,0.13,0.135,0.155,0.185,0.23,
     *0.255,0.285,0.315,0.36,0.41,0.5/ 
C
      DATA XANGLE/0.0,20.0,40.0,60.0,80.0,100.0,120.0,130.0,140.0,145.0,
     1150.0,155.0,160.0,162.5,165.0/ 
C
C
      CALL ERRSET(63,.TRUE.,.FALSE.,.FALSE.,.TRUE.,200)
C
C     
C     READ CCHART CARD
C
      WRITE (NOUT,101)
  101 FORMAT (/T15,'*** CCHART VAX VERSION 12.4 - 3 OCT 1986 ***'///)
      WRITE (NOUT,102) XINTR
  102 FORMAT (/' THE I/I(COR) VALUE IS: ',F6.2)
      IF (NPOPT6.EQ.0) NOUT=6
      IF (NPOPT6.EQ.1) NOUT=28
      READ (NIN,120) W,TTHETA,SCMAX,NSC1,NTYPE,NCURVE,NSUPP,NLIST,NPR,NC
     1C,SCA,SCB,SCC,SCD,SCE,XPON1,XPON2,NFLAG,CSIZE 
      WRITE (NOUT,120) W,TTHETA,SCMAX,NSC1,NTYPE,NCURVE,NSUPP,NLIST,NPR,
     1NCC,SCA,SCB,SCC,SCD,SCE,XPON1,XPON2,NFLAG,CSIZE
  120 FORMAT (3F6.2,7I2,3X,5F5.4,2X,2F4.1,I2,F8.1)
      MCURVE=NCURVE+1
      IF (NCURVE.EQ.1) CFRAC=0.0
      IF (XPON1.NE.0.0) EXPON1=XPON1
      IF (XPON2.NE.0.0) EXPON2=XPON2
      IF (XPON1.NE.0.0 .AND. XPON2.EQ.0.0) EXPON2=XPON1
      IF (NCURVE.EQ.5) CFRAC=XPON1 
      IF (NFLAG.EQ.0) GO TO 110
      READ (NIN,100) FILNAM
  100 FORMAT (A12)
  110 CONTINUE
      IF (CUTOFF.LE.0.0)  CUTOFF=1.5  
      IF(NPR.LE.0) NPR=1 
      IF (NCURVE.NE.1) GO TO 140  
      AMULT=3.0 
      WRITE (NOUT,130)  
  130 FORMAT (32H0GAUSSIAN CURVE WILL BE COMPUTED) 
      GO TO 160   
  140 AMULT=25.0
      WRITE (NOUT,150) 
  150 FORMAT (30H0CAUCHY CURVE WILL BE COMPUTED)
  160 IF (NTYPE) 170,220,180
  170 NTYPE=NPUNCH 
      GO TO 200 
180   IF (NTYPE-6) 190,190,220 
  190 NTYPE=NOUT 
  200 IF (SCA.LE.0.0) SCA=0.1 
      IF (NLIST.LE.0) NLIST=1 
  220 IF (NTYPE.GT.2) WRITE (NOUT,230) NTYPE,SCB,SCA,SCB,SCD,SCC,SCD,SCE
  230 FORMAT (//53H PRINTABLE SUMMARY TABLE WILL BE LISTED ON TAPE UNIT 
     1I2/40H REFLECTIONS OMITTED FOR D GREATER THAN F6.4,35H IF INTEGRAT
     2ED INTENSITY LESS THAN F6.1/35H REFLECTIONS OMITTED FOR D BETWEEN 
     3F6.4,5H AND F6.4,35H IF INTEGRATED INTENSITY LESS THAN F6.1/37H RE
     4FLECTIONS OMITTED FOR D LESS THAN F6.4,35H IF INTEGRATED INTENSITY
     5 LESS THAN F6.1)
C     IF W=0.0 USE NBS MEASURED FWHM TABLE 
      IF (W .GT. 0.01) GO TO 212  
      W = 0.12
      TTHETA = 40.0 
      DO 723 I=1,15
723   TABLE(I) = TABLE3(I)
      GO TO 249
212   IF (W.GE.1.0) THEN
      NWIDTH=W+0.002
      IF (NWIDTH.GE.10) GO TO 1240
      GO TO (1211,1212,1213,1214,1215,1216,1217,1218,1219),NWIDTH
 1211 DO 2121 I=1,15
 2121 TABLE(I)=TABLE1(I)
      GO TO 250
 1212 DO 2122 I=1,15
 2122 TABLE(I)=TABLE2(I)
      GO TO 250
 1213 DO 2123 I=1,15
 2123 TABLE(I)=TABLE3(I)
      GO TO 250
 1214 DO 2124 I=1,15
 2124 TABLE(I)=TABLE4(I)
      GO TO 250
 1215 DO 2125 I=1,15
 2125 TABLE(I)=TABLE5(I)
      GO TO 250
 1216 DO 2126 I=1,15
 2126 TABLE(I)=TABLE6(I)
      GO TO 250
 1217 DO 2127 I=1,15
 2127 TABLE(I)=TABLE7(I)
      GO TO 250
 1218 DO 2128 I=1,15
 2128 TABLE(I)=TABLE8(I)
      GO TO 250
 1219 DO 2129 I=1,15
 2129 TABLE(I)=TABLE9(I)
      GO TO 250
 1240 READ (NTERMI,1241) TABLE0
 1241 FORMAT (15F5.2)
      DO 1242 I=1,15
 1242 TABLE(I)=TABLE0(I)
      GO TO 250
      ELSE
      DO 240  I=1,15 
      IF (XANGLE(I).LT.TTHETA) GO TO 240
      ITEMP=I-1  
      XPART=TTHETA-XANGLE(ITEMP)
      YPART=XANGLE(I)-XANGLE(ITEMP)
      FRAC=XPART/YPART  
      HWU=(FRAC*(TABLE2(I)-TABLE2(ITEMP)))+TABLE2(ITEMP)
      HWL=(FRAC*(TABLE1(I)-TABLE1(ITEMP)))+TABLE1(ITEMP)
      DIF=(W-HWL)/(HWU-HWL)
      GO TO 250
  240 CONTINUE
      END IF
  250 DO 260  J=1,15  
  260 TABLE(J)=TABLE1(J)+DIF*(TABLE2(J)-TABLE1(J))
249   WRITE (NOUT,270) W,TTHETA,WL1,WL2 
  270 FORMAT(/20H   THE HALF-WIDTH ISF5.2,25H AT THE DIFFRACTION ANGLEF6
     1.2,9H (2THETA)/31H   THE ALPHA ONE WAVE LENGTH ISF8.5/31H   THE AL
     2PHA TWO WAVE LENGTH ISF8.5)
      WRITE (NOUT,251,ERR=9966) (XANGLE(J),J=1,15),(TABLE(K),K=1,15)
251   FORMAT ('0ANGLE=',4X,15F6.1/' FWHM=',5X,15F6.3) 
9966  FRAC=WL2/WL1 
C
C     READ CCHART DATA INPUT FOR INTERRUPTED PLOT
C
      IF (NPLOT.GT.0) GO TO 330  
      IF (NPLOT.EQ.-2) GO TO 300
      NPLOT=IABS(NPLOT)
      DO 290  N=1,NREFL
      READ (NPLOT) TTH1(N),D(N),IH(N),IK(N),IL(N),XINT1(N),XINT3(N),XINT
     15
      WRITE (NOUT,310) TTH1(N),D(N),IH(N),IK(N),IL(N),XINT1(N),XINT3(N),
     1XINT5 
  310 FORMAT (2F10.5,1X,3I3,3F10.5)
  290 CONTINUE  
      GO TO 330 
  300 DO 320  N=1,NREFL
      READ (NIN,310) TTH1(N),D(N),IH(N),IK(N),IL(N),XINT1(N),XINT3(N),XI
     1NT5 
      WRITE (NOUT,310) TTH1(N),D(N),IH(N),IK(N),IL(N),XINT1(N),XINT3(N),
     1XINT5 
  320 CONTINUE
  330 DO 340  I=1,8001
  340 Y(I)=0.0
      IF (NFLAG.NE.2) GO TO 323
C     SIMULATE TRACE FOR CUK(ALPHA) IF LAMBDA.NE.CUK(ALPHA)
      IF (WL1.EQ.1.5405981) GO TO 323
      RATIO=1.5405981/WL1
      DO 321 I=1,NREFL
      SINTH=RATIO*SIN(TTH1(I)/RAD)
      IF (ABS(SINTH).GE.1.0) GO TO 322
  321 TTH1(I)=RAD*ASIN(SINTH)
      GO TO 323 
  322 NREFL=I 
  323 CONTINUE
      K=2
      M=1 
      IREFL=NREFL
      IF (TTH1(1).GE.5.0) GO TO 345
      SANGLE=0.00  
      UANGLE=160.00
      RESET=-1.00
  345 TTHCON=SANGLE
      DO 470  II=1,NREFL
      IF (TTH1(II).LE.UANGLE) GO TO 360
      IREFL=II-1 
      GO TO 480 
  360 IF (NCURVE.EQ.3) GO TO 301
      XINT2(II)=0.5*XINT1(II)
      X=FRAC*SIN(TTH1(II)/RAD) 
      TTH2(II)=0.0 
      IF (X.LT.1.0) TTH2(II)=RAD*ATAN(X/SQRT(1.0-X**2))
C     CHECK FOR REFLECTION     RANGE FOR HALF WIDTH DETERMINATION
  370 IF (XANGLE(K).GE.TTH1(II)) GO TO 380
      K=K+1
      GO TO 370 
C
C     SIMULATE GUINIER DATA USING BROWN AND EDMONDS DATA 
C     ALPHA ONE ONLY
C
  301 IF (ANGLE2(K).GE.TTH1(II)) GO TO 302
      K=K+1
      GO TO 301
  302 KTEMP=K-1
      XPART=TTH1(II)-ANGLE2(KTEMP)
      YPART=ANGLE2(K)-ANGLE2(KTEMP)
      RATIO=XPART/YPART
      WIDL=RATIO*(TAB4(K)-TAB4(KTEMP))+TAB4(KTEMP)
      WIDH=RATIO*(TAB5(K)-TAB5(KTEMP))+TAB5(KTEMP)
      WIDA=(WIDL+WIDH)*0.5
      EXPON1=RATIO*(TAB6(K)-TAB6(KTEMP))+TAB7(KTEMP)
      EXPON2=RATIO*(TAB7(K)-TAB7(KTEMP))+TAB7(KTEMP)
      CZREFL=2.0*XINT1(II)/(WIDA*PI)
      ISTART=(TTH1(II)-CZREFL*25.0)*50.0-RESET
      INT=WIDA*2500.0
      ISTOP=ISTART+INT
      IF (ISTART.LE.O) ISTART=1
      IF (ISTOP.GT.8001) ISTOP=8001
      DO 304 J=ISTART,ISTOP
      X=J
      DEL=TTH1(II)-((X+RESET)/50.0)
      DELSQ=DEL*DEL
      IF (DEL.GT.0.0) Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WIDL**2))**EXPON1
  304 IF (DEL.LE.0.0) Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WIDH**2))**EXPON2
      GO TO 470
  380 KTEMP=K-1
      XPART=TTH1(II)-XANGLE(KTEMP) 
      YPART=XANGLE(K)-XANGLE(KTEMP)
      WREFL=(XPART/YPART)*(TABLE(K)-TABLE(KTEMP))+TABLE(KTEMP)
      WSQ=WREFL*WREFL 
C     IF (NCURVE.EQ.1) GO TO 390
      CZREFL=2.0*XINT1(II)/(WREFL*PI)
C     GO TO 400 
  390 GZREFL=XINT1(II)/WREFL
C     SET RANGE OF Y CALCULATION DEPENDING ON HALF WIDTH 
  400 ISTART=(TTH1(II)-WREFL*AMULT)*50.0-RESET
      INT=WREFL*AMULT*100.0 
      ISTOP=ISTART+INT 
C
C     CHECK LIMITS OF CALCULATION RANGE
C  
      IF (ISTART.LE.0) ISTART=1
      IF (ISTOP.GT.8001) ISTOP=8001
C     CALCULATE PROFILE FOR A REFLECTION 
      DO 420  J=ISTART,ISTOP
      X=J
      DEL=TTH1(II)-((X+RESET)/50.0)
      DELSQ = DEL*DEL
      IF (NCURVE.EQ.1) GO TO 410
      IF (NCURVE.EQ.5) GO TO 408
C     CAUCHY PROFILE FOR A REFLECTION 
      IF (DEL.GT.0.0) GO TO 404
      IF (EXPON1.EQ.1.0) GO TO 402
      IF (EXPON1.EQ.2.0) GO TO 403
      Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))**EXPON1
      GO TO 420
  402 Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))
      GO TO 420
  403 Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))**2
      GO TO 420
  404 IF (EXPON2.EQ.1.0) GO TO 406
      IF (EXPON2.EQ.2.0) GO TO 407
      Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))**EXPON2
      GO TO 420
  406 Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))
      GO TO 420
  407 Y(J)=Y(J)+CZREFL/(1.0+(4.0*DELSQ/WSQ))**2
      GO TO 420
  408 Y(J)=Y(J)+(CFRAC*CZREFL/(WSQ+4.0*DELSQ)) 
C     GAUSSIAN PROFILE FOR A REFLECTION 
  410 Y(J)=Y(J)+(1.0-CFRAC)*GZREFL*EXP(-PI*DELSQ/WSQ) 
  420 CONTINUE  
C 
C     REPEAT PROFILE FOR ALPHA2 
      IF (NFLAG.EQ.2) WL2=0.0 
      IF (WL2.EQ.0.0) GO TO 470 
      ZPART=TTH2(II)-XANGLE(KTEMP) 
      XREFL=(ZPART/YPART)*(TABLE(K)-TABLE(KTEMP))+TABLE(KTEMP)
      XSQ=XREFL*XREFL 
C     IF (NCURVE.EQ.1) GO TO 430
      CYREFL=2.0*XINT2(II)/(XREFL*PI)  
C     GO TO 440 
  430 GYREFL=XINT2(II)/XREFL 
  440 KSTART=(TTH2(II)-XREFL*AMULT)*50.0-RESET  
      KSTOP=KSTART+INT
      IF (KSTART.LE.0) KSTART=1
      IF (KSTOP.GT.8001) KSTOP=8001 
      DO 460  J=KSTART,KSTOP 
      X=J 
      DEL=TTH2(II)-((X+RESET)/50.0)  
      DELSQ = DEL*DEL
      IF (TTH2(II).LE.0) GO TO 470 
      IF (NCURVE.EQ.1) GO TO 450
      IF (NCURVE.EQ.5) GO TO 425
      IF (DEL.GT.0.0) GO TO 444
      IF (EXPON1.EQ.1.0) GO TO 442
      IF (EXPON1.EQ.2.0) GO TO 443
      Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))**EXPON1
      GO TO 460
  442 Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))
      GO TO 460
  443 Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))**2
      GO TO 460
  444 IF (EXPON2.EQ.1.0) GO TO 446
      IF (EXPON2.EQ.2.0) GO TO 447
      Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))**EXPON2
      GO TO 460
  446 Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))
      GO TO 460
  447 Y(J)=Y(J)+CYREFL/(1.0+(4.0*DELSQ/WSQ))**2
      GO TO 460 
  425 Y(J)=Y(J)+(CFRAC*CYREFL/(XSQ+4.0*DELSQ))
C     GAUSSIAN PROFILE
  450 Y(J)=Y(J)+(1.0-CFRAC)*GYREFL*EXP(-PI*DELSQ/XSQ)
  460 CONTINUE 
  470 CONTINUE
C
C     APPLY SCHERRER CRYSTALLITE BROADENING
C
      IF (CSIZE.NE.0.0) THEN
      CONST1=2.77258872
      CONST2=0.93943728
      WRITE (6,6049)
 6049 FORMAT (/' ENTERING THE SCHERRER LOOP')
      SCHERR=0.89*WL1/CSIZE
      NSCH=0
      DO 6070 I=1,8001
      IF (Y(I).EQ.0.0) GO TO 6070
      TH0=TTHCON+0.02*(I-1)
      BPARAM=(RAD)*SCHERR/COS(TH0/RAD)
      BWIDTH=2.8*BPARAM
      NBW=BWIDTH*50
      NWMID=NBW/2+1
      NWEND=2*NWMID-1
      IF (NWEND.GT.2001) THEN
      IF (NSCH.EQ.0) WRITE (6,6052)
 6052 FORMAT (/' TAIL OF SCHERRER COMPONENT BROADER THAN SPACE ALLOCATED
     *'/T5,'SOME TRUNCATION WILL RESULT')
      NSCH=1
      NWMID=1001
      NWEND=2001
      ELSE
      ENDIF
      IF (MOD(I-1,1000).EQ.0) THEN
      ANG1=((I-1)*0.02)+TTHCON
      WRITE (6,6055) I,ANG1,BPARAM,NWMID,NWEND
 6055 FORMAT (/' AT POINT ',I4/T5,' 2THETA = ',F6.2,', THE HALF-WIDTH
     * IS: ',F6.2,', NWMID = ',I4,', NWEND = ',I4)
      ELSE
      ENDIF
C     TH0=TTHCON+0.02*NWMID
      DO 6060 J=1,NWEND
C     TH1=TTHCON+0.02*(J-NWMID)
 6060 R(J)=(1.0/(BPARAM*SQRTPI))*EXP(-1.0*(((J-NWMID)*0.04)/BPARAM)**2)
C
C      NORMALIZE THE R MATRIX
C
      SUMR=0.0
      DO 6062 J=1,NWEND
 6062 SUMR=SUMR+R(J)
      DO 6063 J=1,NWEND
 6063 R(J)=R(J)/SUMR
C     IF (MOD(I-1,1000).EQ.0) WRITE (6,6059) (R(N),N=1,NWEND)
 6059 FORMAT (10F8.4)
C     IF (MOD(I-1,1000).EQ.0) WRITE (6,6061) I
 6061 FORMAT (/' EXECUTING THE MULTIPLICATION LOOP: I = 'I4)
      DO 6070 J=1,NWEND
      K=I+J-NWMID
      IF (K.LT.1 .OR. K.GT.8001) GO TO 6070
      YR(K)=YR(K)+Y(I)*R(J)
 6070 CONTINUE
      WRITE (6,6071)
 6071 FORMAT (/' LEAVING SCHERRER LOOP: ENTERING THE PEAK LOOP')
      PEAKY=Y(1)
      PEAKYR=YR(1)
      DO 6080 I=1,8000
      IF (PEAKY.LT.Y(I+1)) PEAKY=Y(I+1)
 6080 IF (PEAKYR.LT.YR(I+1)) PEAKYR=YR(I+1)
      XINTR=XINTR*(PEAKYR/PEAKY)
      WRITE (6,6081) XINTR
 6081 FORMAT (/' THE REVISED I/I(COR) VALUE IS: ',F6.2)
      DO 6085 I=1,8001
 6085 Y(I)=YR(I)
      ELSE
      END IF
      WRITE (6,6086)
 6086 FORMAT (/' RE-ENTERING THE MAIN PROGRAM')
C
C     SCALE THE CALCULATED PATTERN
C
  480 X=Y(1)
      DO 490  J=2,8001
      IF (X.LE.Y(J)) X=Y(J) 
  490 CONTINUE  
      IF (SCMAX.EQ.0.0) SCMAX=100.2
  500 ZSCALE=AMOD(SCMAX,1.0)
      SCMAX=SCMAX-ZSCALE
      NSCALE=10.0*(ZSCALE+0.02)
      IF (NSCALE.EQ.0) NSCALE=2
      LENGTH=40*2**(NSCALE-1)
      XSCAL=1.0 
      IF (TTH1(IREFL).GT.164.0) GO TO 510 
      VANGLE=UANGLE-1.0  
      IF(TTH1(IREFL).GT.VANGLE) GO TO 510
      XSCAL=(TTH1(IREFL)-SANGLE)/160.0 
      LENGTH=FLOAT(LENGTH)*XSCAL+1.0
  510 NPLT=8000.0*XSCAL
      XSCAL=LENGTH  
      WRITE (NOUT,520) ZSCALE,SCMAX,NSCALE,LENGTH,XSCAL  
  520 FORMAT (1H1, 10H ZSCALE = F7.1/7H  SC = F7.1/11H  NSCALE = I2/11H 
     1 LENGTH = I6/11H  XSCALE = F7.1)                                  CHRT0510
      SCALE=SCMAX/X
      DO 530  J=1,8001
  530 Y(J)=Y(J)*SCALE
      IF (SCMAX.EQ.SCMAX2) GO TO 690
      DO 610  II=M,IREFL
      IF (TTH1(II).LE.UANGLE) GO TO 550  
  540 TTH2(II)=0.0
      GO TO 610 
  550 NANG=((TTH1(II)-SANGLE)/0.02)+1.0
      IF (Y(NANG)-Y(NANG-1)) 580,600,560 
  560 IF (NANG-8001) 570,600,540
  570 IF (Y(NANG+1).LE.Y(NANG)) GO TO 600 
      NANG=NANG+1
      GO TO 560
  580 IF (Y(NANG-1).GE.Y(NANG-2)) GO TO 590 
      NANG=NANG-1 
      GO TO 580  
  590 NANG=NANG-1
  600 XINT2(II)=Y(NANG)
      TTH2(II)=(FLOAT(NANG)-1.0)*0.02+SANGLE
  610 CONTINUE  
C
C     OUTPUT COMPLETE  I VS.2 THETA TABLE (2 THETA=0.02)
C
      IF (NPOPT7.EQ.0) NOUT=6
      IF (NPOPT7.EQ.1) NOUT=28
      IF (NSUPP.EQ.0) GO TO 690
      X1=SANGLE
      X2=SANGLE+1.00
      X3=SANGLE+2.0
      X4=SANGLE+3.00
      X5=SANGLE+4.0 
      NNN=NPLT+1
      NN=51 
      N1=1 
      N2=51
      N3=101
      N4=151
      N5=201 
620   WRITE (NOUT,630) (ITITLE(I),I=1,80)
630   FORMAT('1',19X,80A1///)
      WRITE (NOUT,640)  
  640 FORMAT (119H 2THETA   INTENSITY       2THETA   INTENSITY       2TH
     1ETA   INTENSITY       2THETA   INTENSITY       2THETA   INTENSITY)
  650 WRITE (NOUT,660) X1,Y(N1),X2,Y(N2),X3,Y(N3),X4,Y(N4),X5,Y(N5)
  660 FORMAT (F7.2,F10.2,5X,2F10.2,5X,2F10.2,5X,2F10.2,5X,2F10.2)
      X1=X1+0.02 
      X2=X2+0.02
      X3=X3+0.02
      X4=X4+0.02 
      X5=X5+0.02 
      N1=N1+1 
      N2=N2+1
      N3=N3+1
      N4=N4+1  
      N5=N5+1 
      IF (N1.LT.NN) GO TO 650
      NN=NN+250
      IF (NN-NNN) 670,680,690 
  670 N1=N1+200
      N2=N2+200
      N3=N3+200 
      N4=N4+200
      N5=N5+200
      X1=X1+4.00  
      X2=X2+4.00
      X3=X3+4.00  
      X4=X4+4.00
      X5=X5+4.00
      GO TO 620
  680 X1=165.00
      WRITE (NOUT,660) X1,Y(8001)
C
C     PLOT THE DIFFRACTOMETER TRACE
C
C     PREPARE HEADING FOR SIMULATED PLOT 
  690 IF (NPOPT8.EQ.0) NOUT=6
      IF (NPOPT8.EQ.1) GO TO 686
      IF (NCC.EQ.0) WRITE (NOUT,105) (ITITLE(I),I=1,80)
 105  FORMAT (1H1,80A1)
C     IF (NCC.EQ.0) CALL PLOTT(Y,NSC1,NPLT,LENGTH,NSCALE)
      DSCMAX=SCMAX
  683 WRITE (6,6900) DSCMAX
 6900 FORMAT (/' THE SCALE FOR THE PLOT IS ',F8.1,' DO YOU WANT TO MODIF
     *Y THIS SCALE'/T5,'FOR THE GRAPHICAL OUTPUT (Y OR [N]):  ',$)
      READ (5,6901) NCR,NQUES
 6901 FORMAT (Q,A)
      IF (NCR.EQ.0) NQUES='N'
      IKEY=STR$UPCASE(NQUES,NQUES)
      IF (NQUES.EQ.'N') GO TO 684
      IF (NQUES.NE.'Y') GO TO 683
 6902 WRITE (6,6903) 
 6903 FORMAT (/' ENTER A NEW SCALE MAX. THE GRAPH WILL TRUNCATE AT 100')
 6683 WRITE (6,6908)
 6908 FORMAT (T5,'ENTER SCALE:  ',$)
      READ (5,6904,ERR=6902) DSCMAX
 6904 FORMAT (F10.0)
  684 NSCMAX=DSCMAX
      ESCALE=DSCMAX/100.0
      DO 685 I=1,8001
      IY(I)=ESCALE*Y(I)+1.0
  685 IF (IY(I).GT.NSCMAX) IY(I)=NSCMAX
D     CALL GRAPH2 (IY,SANGLE,UANGLE,TTHCON,HEADER)
C     CALL GRAPH2 (IY,SANGLE,UANGLE,TTHCON,'NOME56789012345678')
 6907 WRITE (6,6905)
 6905 FORMAT (/' DO YOU WANT TO REPLOT WITH A NEW SCALE (Y OR [N]):  '
     *,$)
      READ (6,6906) NCR,NQUES
 6906 FORMAT (Q,A)
      IF (NCR.EQ.0) NQUES='N'
      IKEY=STR$UPCASE(NQUES,NQUES)
      IF (NQUES.EQ.'Y') GO TO 6683
      IF (NQUES.NE.'N') GO TO 6907
C     PREPARE SEPARATE FILE FOR TRACE
  686 IF (NFLAG.EQ.0) GO TO 695 
      OPEN (UNIT=MOUT,FILE=FILNAM,STATUS='NEW',FORM='UNFORMATTED',
     *      DEFAULTFILE='.CMB')
      WRITE (MOUT) (ITITLE(I),I=1,80),XINTR,SCMAX,(Y(I),I=1,8001)
      CLOSE (UNIT=MOUT)    
      MOUT=MOUT+1 
  695 CONTINUE
      IF (SCMAX2.LE.0.0) GO TO 700 
      X=X*SCALE
      SCMAX=SCMAX2
      NSC1=NSC2
      SCMAX2=0.0 
      GO TO 500 
  700 IF (NLIST.EQ.0) GO TO 740
      K=2
      XLIST=ABS(FLOAT(NLIST))
      DO 730  N=M,IREFL 
  710 IF (XANGLE(K).GE.TTH1(N)) GO TO 720  
      K=K+1
      GO TO 710
  720 KTEMP=K-1
      XPART=TTH1(N)-XANGLE(KTEMP) 
      YPART=XANGLE(K)-XANGLE(KTEMP)
      WREFL=(XPART/YPART)*(TABLE(K)-TABLE(KTEMP))+TABLE(KTEMP)
      IF  (ABS(TTH2(N)-TTH1(N)).GT.XLIST*WREFL) XINT2(N)=0.0 
  730 CONTINUE
C
C     OUTPUT THE ABRIDGED SUMMARY
C
  740 NTYPE=6
      IF (NTYPE.NE.NPUNCH) GO TO 760 
      ASSIGN 920 TO NTYP1
      NPR=1 
      IF (NPOPT9.EQ.0) WRITE(NTYPE,750) (ITITLE(I),I=1,LENX)
750   FORMAT(80A1)
  760 DO 940  NPRINT=1,NPR
      TTHZ=0.0 
      NINTPX = 0
      IF (NTYPE.EQ.NPUNCH) GO TO 780
      ASSIGN 900 TO NTYP1
      NNN=0 
      IF (NPOPT9.EQ.0) WRITE (NTYPE,770) (ITITLE(I),I=1,78),
     *(ITITLE(I),I=81,158),
     *(ITITLE(I),I=161,238),(ITITLE(I),I=241,318)
770   FORMAT('1'/1X,78A1/1X,78A1/1X,78A1/1X,78A1/)
  780 IF (NPOPT9.EQ.0) WRITE (NTYPE,790)
  790 FORMAT (10X,51H 2THETA  PEAK     D      H  K  L I(INT) I(PK) I(DS)
     1)
  800 FORMAT (11X,F6.2,1X,F6.2,1X,F6.3,2X,3I3,3I6)
  810 FORMAT (11X,F6.2,1X,F6.2,2X,F6.4,1X,3I3,3I6)
  820 FORMAT (11X,F6.2,7X,1X,F6.3,2X,3I3,I6,6X,I6)
  830 FORMAT (11X,F6.2,7X,2X,F6.4,1X,3I3,I6,6X,I6)
      DO 930  N=1,IREFL
      NINTP=XINT2(N)+0.5
      NINTD=XINT3(N)+0.5
      IF (D(N).GE.SCB) GO TO 850 
      IF (D(N).LT.SCD) GO TO 840
      IF (XINT1(N)-SCC) 930,860,860 
  840 IF (XINT1(N)-SCE) 930,860,860
  850 IF (XINT1(N).LT.SCA) GO TO 930
  860 NINTI=XINT1(N)+0.5
      IF (TTH2(N).EQ.TTHZ.AND.NINTP.EQ.NINTPX) GO TO 880 
      IF (D(N).LT.2.0) GO TO 870
      IF (NPOPT9.EQ.0) WRITE (NTYPE,800) TTH1(N),TTH2(N),D(N),IH(N),
     *IK(N),IL(N),NINTI,NINTP,NINTD
      GO TO NTYP1, (900,920)
  870 IF (NPOPT9.EQ.0) WRITE (NTYPE,810) TTH1(N),TTH2(N),D(N),IH(N),
     *IK(N),IL(N),NINTI,NINTP,NINTD
      GO TO NTYP1, (900,920)
  880 IF (D(N).LT.2.0) GO TO 890
      IF (NPOPT9.EQ.0) WRITE (NTYPE,820) TTH1(N),D(N),IH(N),IK(N),
     *IL(N),NINTI,NINTD
      GO TO NTYP1, (900,920)
  890 IF (NPOPT9.EQ.0) WRITE (NTYPE,830) TTH1(N),D(N),IH(N),IK(N),
     *IL(N),NINTI,NINTD
      GO TO NTYP1, (900,920)
  900 NNN=NNN+1
      IF (NNN.LT.53) GO TO 920 
      IF (NPOPT9.EQ.0) WRITE (NTYPE,910) (ITITLE(I),I=1,78),
     *(ITITLE(I),I=81,158),
     *(ITITLE(I),I=161,238),(ITITLE(I),I=241,318)
910   FORMAT('1'/1X,78A1/1X,78A1/1X,78A1/1X,78A1/)
      IF (NPOPT9.EQ.0) WRITE (NTYPE,790) 
      NNN=0
  920 IF(NPRINT.GT.1) GO TO 929
      IF (XINT1(N).LT.CUTOFF)  GO TO 5
      IF (KOUNT.EQ.120)  GO TO 5
      KOUNT=KOUNT+1
      WRITE(NTAPE1,3) D(N),XINT1(N),IH(N),IK(N),IL(N) 
    3 FORMAT(2F10.5,3I5) 
 5     IF (XINT2(N).LT.CUTOFF)  GO TO 929 
      IF (KOUNT2.EQ.120)  GO TO 929
      IF(TTH2(N).EQ.TTHZ.AND.NINTP.EQ.NINTPX) GO TO 929
      K=N+1
      IF(K.GT.IREFL) GO TO 2 
      NEXT=XINT2(K)+0.5
      IF(TTH2(K).EQ.TTH2(N).AND.NEXT.EQ.NINTP) GO TO 48
    2 MIN1=N
   14 KEY=0 
      MH=0 
      MK=0
      ML=0  
      GO TO 15
   48 IND=0
      LI=0
      KEY=1
      J=N-1 
   49 LI=LI+1 
      J=J+1  
      ITEM(LI)=XINT1(J)+0.5
      IF(TTH2(K).NE.TTH2(N).OR.NEXT.NE.NINTP) GO TO 50
      K=K+1 
      IF(K.GT.IREFL) GO TO 50
      NEXT=XINT2(K)+0.5
      GO TO 49  
   50 MAX=ITEM(1)-ITEM(2)
      IF(MAX.GE.0) GO TO 51  
      MAX1=2 
      MAX2=1
      GO TO 52
   51 MAX1=1
      MAX2=2 
   52 IF(LI.EQ.2) GO TO 61
      DO 53 I=3,LI
      IF(ITEM(I).LE.ITEM(MAX2)) GO TO 53
      IF(ITEM(I).LE.ITEM(MAX1)) GO TO 54
      MAX2=MAX1
      MAX1=I
      GO TO 53
   54 MAX2=I 
   53 CONTINUE 
   61 IF(ITEM(MAX2).NE.0) GO TO 55 
      IF(ITEM(MAX1).EQ.0) GO TO 56
      MIN1=MAX1+N-1
      GO TO 14
   56 IND=0
      GO TO 6
   55 IF(ITEM(MAX1).NE.ITEM(MAX2)) GO TO 57
      IND=1 
    6 J=N-1 
      KOUNT4=0 
      DO 7 L=1,LI
      J=J+1 
      TEM(L)=ABS(TTH2(N)-TTH1(J))
      IF(ITEM(L).EQ.ITEM(MAX1)) KOUNT4=KOUNT4+1
      IF(ITEM(L).NE.ITEM(MAX1)) TEM(L)=100.0
    7 CONTINUE
      XTEMP=TEM(1)-TEM(2)
      IF(XTEMP.LE.0.0) GO TO 10 
      MIN1=2 
      MIN2=1
      GO TO 11
   10 MIN1=1
      MIN2=2
   11 IF(LI.EQ.2) GO TO 9
      DO 12 I=3,LI 
      IF(TEM(I).GE.TEM(MIN2)) GO TO 12
      IF(TEM(I).GE.TEM(MIN1)) GO TO 13
      MIN2=MIN1
      MIN1=I
      GO TO 12 
   13 MIN2=I
   12 CONTINUE 
      IF(IND.NE.0) GO TO 23
      MIN1=MIN1+N-1
      GO TO 14
   23 IF(KOUNT4.GT.2) KEY=2
      GO TO 9 
   57 KOUNT3=0 
      DIV2=ITEM(MAX1)
      DO 58 I=1,LI
      DIV1=ITEM(I)  
      XTEMP=DIV1/DIV2 
      IF(XTEMP.GE.0.1) KOUNT3=KOUNT3+1 
   58 CONTINUE 
      IF(KOUNT3.GT.1) GO TO 59
      MIN1=MAX1+N-1
      GO TO 14
   59 IF(KOUNT3.GT.2) GO TO 60
      MIN1=MAX1
      MIN2=MAX2
      GO TO 9
   60 MIN1=MAX1 
      MIN2=MAX2 
      KEY=2 
    9 MIN1=MIN1+N-1  
      MIN2=MIN2+N-1 
      MH=IH(MIN2)
      MK=IK(MIN2)
      ML=IL(MIN2) 
   15 KOUNT2=KOUNT2+1
      WRITE(NTAPE2,4) KEY,D(MIN1),XINT2(N),IH(MIN1),IK(MIN1),IL(MIN1),
     1MH,MK,ML
    4 FORMAT(I5,2F10.5,6I5) 
  929 TTHZ=TTH2(N) 
      NINTPX=NINTP
  930 CONTINUE 
  940 CONTINUE
      REWIND NTAPE1
      REWIND NTAPE2
      NUMBER=1
      READ(NTAPE1,3) (D(N),XINT1(N),IH(N),IK(N),IL(N),N=1,KOUNT)
   16 TEM(1)=XINT1(1)-XINT1(2)  
      TEM(2)=XINT1(2)-XINT1(3)
      TEM(3)=XINT1(1)-XINT1(3) 
      IF(TEM(1).LT.0.0) GO TO 34
      IF(TEM(2).GE.0.0) GO TO 35
      IF(TEM(3).GE.0.0) GO TO 36
      MAX=3 
      MID=1
      MIN=2
      GO TO 37
   34 IF(TEM(2).LT.0.0) GO TO 38
      IF(TEM(3).GE.0.0) GO TO 39
      MAX=2 
      MID=3  
      MIN=1
      GO TO 37
 35   MAX=1
      MID=2
      MID=2 
      MIN=3
      GO TO 37 
 36   MAX=1 
      MID=3
      MIN=2
      GO TO 37  
   38 MAX=3
      MID=2
      MIN=1
      GO TO 37
   39 MAX=2
      MID=1 
      MIN=3
   37 DO 40 N=4,KOUNT  
      IF(XINT1(N).LE.XINT1(MIN)) GO TO 40
      IF(XINT1(N).LE.XINT1(MID)) GO TO 41
      IF(XINT1(N).LE.XINT1(MAX)) GO TO 42
      MIN=MID
      MID=MAX
      MAX=N
      GO TO 40
   42 MIN=MID
      MID=N 
      GO TO 40
   41 MIN=N  
   40 CONTINUE
      IF (NPOPT0.EQ.0) NOUT=6
      IF (NPOPT0.EQ.1) NOUT=28
      IF (NUMBER.EQ.1) WRITE (NOUT,20) (ITITLE(I),I=1,80) 
20    FORMAT(1H1,1X,80A1)
      IF (NUMBER.EQ.2) WRITE (NOUT,210) (ITITLE(I),I=1,80)
  210 FORMAT(1H1,1X,80A1) 
      IF(NUMBER.EQ.1) WRITE (NOUT,19) 
   19 FORMAT (/1X,43HCALCULATED PATTERN - INTEGRATED INTENSITIES)
      IF(NUMBER.EQ.2) WRITE (NOUT,21)
   21 FORMAT (/1X,36HCALCULATED PATTERN - PEAK ITENSITIES) 
      IN1=XINT1(MAX)+0.5
      IN2=XINT1(MID)+0.5  
      IN3=XINT1(MIN)+0.5
      FMT2(7)=SEVEN
      FMT2(9)=THREE
      FMT2(16)=SEVEN
      FMT2(18)=THREE
      FMT2(25)=SEVEN
      FMT2(27)=THREE
      IF(D(MAX).GE.2.0) GO TO 71
      FMT2(7)=EIGHT
      FMT2(9)=FOUR
   71 IF(D(MID).GE.2.0) GO TO 72
      FMT2(16)=EIGHT
      FMT2(18)=FOUR
   72 IF(D(MIN).GE.2.0) GO TO 73
      FMT2(25)=EIGHT 
      FMT2(27)=FOUR
   73 WRITE (NOUT,FMT2) D(MAX),D(MID),D(MIN),IN1,IN2,IN3
      WRITE (NOUT,24) (ITITLE(N),N=1,160) 
   24 FORMAT(/1X,40A1,1X,40A1//1X,80A1//
     1 ' REF. Smith D. K.                                ',/,
     2 ' Department of Geosciences,                                 ',/,
     3 ' The Pennsylvania State University                          ')
      IF (ITRANS.NE.0 .AND. NUMBER.EQ.1) GO TO 989
  906 WRITE(NOUT,25)(ITITLE(N),N=161,185),DENSC,(ITITLE(N),N=186,240)
   25 FORMAT(/1X,4HSYS.,1X,12A1,1X,4HS.G.,1X,13A1,1X,2HDX,1X,F6.3,1X,1HZ
     1,1X,5A1,1X,8HLOCALITY,1X,50A1)
      IF (ABS(NSG).GE.1 .AND. ABS(NSG).LE.74 .OR. ABS(NSG).GE.231
     *.AND. ABS(NSG).LE.241) NPRN1=3
      IF (ABS(NSG).GE.75 .AND. ABS(NSG).LE.194) NPRN1=2
      IF (ABS(NSG).GE.195 .AND. ABS(NSG).LE.230 .OR. NSG.EQ.146
     *.OR. NSG.EQ.148 .OR. NSG.EQ.155 .OR. NSG.EQ.160 .OR. NSG.EQ.161
     *.OR. NSG.EQ.166 .OR. NSG.EQ.167) NPRN1=1
      GO TO (971,973,975), NPRN1
  971 WRITE (NOUT,972) REALA
  972 FORMAT (' A = ',F9.4)
      GO TO 981
  973 WRITE (NOUT,974) REALA,C
  974 FORMAT (' A = ',F9.4,22X,' C = ',F9.4)
      GO TO 981
  975 WRITE (NOUT,976) REALA,B,C
  976 FORMAT (' A = ',F9.4,4X,' B = ',F9.4,4X,' C = ',F9.4)
  981 NPRN2=5
      IF (NSG.EQ.146 .OR. NSG.EQ.148 .OR. NSG.EQ.155 .OR. NSG.EQ.160
     *.OR. NSG.EQ.161 .OR. NSG.EQ.166 .OR. NSG.EQ.167) NPRN2=1
      IF (NSG.LE.-3 .AND. NSG.GE.-15 .OR. NSG.GE.231 .AND. NSG.LE.240)
     *NPRN2=2
      IF (NSG.GE.3 .AND. NSG.LE.15) NPRN2=3
      IF (NSG.EQ.1 .OR. NSG.EQ.2) NPRN2=4
      GO TO (983,985,987,995,991),NPRN2
  983 WRITE (NOUT,984) ALPHA
  984 FORMAT (' Alpha = ',F7.2)
      GO TO 992
  985 WRITE (NOUT,986) BETA
  986 FORMAT (18X,' Beta = ',F7.2)
      GO TO 992
  987 WRITE (NOUT,996) GAMMA
  996 FORMAT (36X,' Gamma = ',F7.2)
      GO TO 992
  995 WRITE (NOUT,990) ALPHA,BETA,GAMMA
  990 FORMAT (' Alpha = ',F7.2,2X,' Beta = ',F7.2,3X,' Gamma = 'F7.2)
      GO TO 992
  991 WRITE (NOUT,994)
  994 FORMAT (' ')
      GO TO 992
  989 CELL(1)=REALA
      CELL(2)=B 
      CELL(3)=C 
      CELL(4)=ALPHA 
      CELL(5)=BETA
      CELL(6)=GAMMA
      GO TO (901,902,903,904,905), ITRANS
  901 REALA=CELL(2) 
      B=CELL(3) 
      C=CELL(1)  
      ALPHA=CELL(5)
      BETA=CELL(6) 
      GAMMA=CELL(4) 
      GO TO 906 
  902 REALA=CELL(3)
      B=CELL(1) 
      C=CELL(2)
      ALPHA=CELL(6) 
      BETA=CELL(4) 
      GAMMA=CELL(5)
      GO TO 906 
  903 REALA=CELL(1) 
      B=CELL(3)
      C=CELL(2)
      ALPHA=CELL(4)
      BETA=CELL(6)
      GAMMA=CELL(5)
      GO TO 906 
  904 REALA=CELL(2)
      B=CELL(1)
      C=CELL(3)
      ALPHA=CELL(5)
      BETA=CELL(4)
      GAMMA=CELL(6) 
      GO TO 906 
  905 REALA=CELL(3)
      B=CELL(2) 
      C=CELL(1) 
      ALPHA=CELL(6)
      BETA=CELL(5)
      GAMMA=CELL(4)
      GO TO 906
  992 WRITE (NOUT,26) (ITITLE(N),N=241,320),SC(5),WL1
   26 FORMAT(/1X,4HREF.,80A1//1X,40HSCALE FACTOR (INTEGRATED INTENSITIES
     1) = ,E12.4,11H  LAMBDA = ,F7.4)
      WRITE (NOUT,30)
   30 FORMAT(5X,1HD,5X,3HI/I,3X,1HH,2X,1HK,2X,1HL,17X,1HD,5X,3HI/I,3X,
     11HH,2X,1HK,2X,1HL)
      L=5  
      J=5
      K=1
   18 DO 27 N=K,L
      M=N+J 
      NINTP=XINT1(N)+0.5 
      IN1=TTH2(N)
      IN2=XINT2(N)
      IN3=XINT3(N)
      IF(TTH1(N).EQ.1.0) SIGN1=BLANK
      IF(TTH1(N).EQ.2.0) SIGN1=PLUS  
      IF(D(N).LT.2.0) GO TO 88
      FMT(6)=SEVEN
      FMT(8)=THREE
      FMT(10)=TWO
      FMT1(6)=SEVEN
      FMT1(8)=THREE
      FMT1(10)=TWO
      GO TO 89
   88 FMT(6)=EIGHT
      FMT(8)=FOUR
      FMT(10)=ONE 
      FMT1(6)=EIGHT
      FMT1(8)=FOUR
      FMT1(10)=ONE 
   89 IF(M.GT.KOUNT) GO TO 28
      NEXT=XINT1(M)+0.5
      IN4=TTH2(M)
      IN5=XINT2(M)
      IN6=XINT3(M)
      IF(TTH1(M).EQ.1.0) SIGN2=BLANK
      IF(TTH1(M).EQ.2.0) SIGN2=PLUS 
      IF(D(M).LT.2.0) GO TO 86  
      FMT(33)=SEVEN 
      FMT(35)=THREE
      FMT(37)=TWO
      FMT1(28)=SEVEN   
      FMT1(30)=THREE
      FMT1(32)=TWO
      GO TO 87
  86  FMT(33)=EIGHT
      FMT(35)=FOUR
      FMT(37)=ONE
      FMT1(28)=EIGHT
      FMT1(30)=FOUR 
      FMT1(32)=ONE
   87 IF(NUMBER.EQ.1) GO TO 43 
      IF(TTH1(N).EQ.0.0.AND.TTH1(M).EQ.0.0) GO TO 43
      IF(TTH1(N).GT.0.0.AND.TTH1(M).GT.0.0) WRITE (NOUT,FMT)D(N),NINTP,
     1IH(N),IK(N),IL(N),COMMA,IN1,IN2,IN3,SIGN1,D(M),NEXT,
     2IH(M),IK(M),IL(M),COMMA,IN4,IN5,IN6,SIGN2 
      IF(TTH1(N).GT.0.0.AND.TTH1(M).EQ.0.0) WRITE (NOUT,FMT)D(N),NINTP,
     1IH(N),IK(N),IL(N),COMMA,IN1,IN2,IN3,SIGN1,D(M),NEXT,
     2IH(M),IK(M),IL(M)  
      IF(TTH1(N).EQ.0.0.AND.TTH1(M).GT.0.0) WRITE (NOUT,FMT1)D(N),NINTP,
     1IH(N),IK(N),IL(N),D(M),NEXT,IH(M),IK(M),IL(M),COMMA,IN4,IN5,
     2IN6,SIGN2
      GO TO 45
   43 WRITE (NOUT,FMT1)D(N),NINTP,IH(N),IK(N),IL(N),D(M),NEXT,IH(M),
     1IK(M),IL(M)
      GO TO 45
   28 IF(NUMBER.EQ.1) GO TO 46
      IF(TTH1(N).EQ.0.0) GO TO 46
      WRITE (NOUT,FMT)D(N),NINTP,IH(N),IK(N),IL(N),COMMA,IN1,IN2,IN3,SIG
     *N1
      GO TO 45
   46 WRITE (NOUT,FMT1)D(N),NINTP,IH(N),IK(N),IL(N)
   45 IF(MOD(N,5).EQ.0) WRITE (NOUT,33) BLANK
   33 FORMAT(5X,A1) 
   27 CONTINUE 
      IF(J.NE.5)  GO TO 31
      IF(KOUNT.LE.10) GO TO 32
      WRITE(NOUT,988) 
988   FORMAT (1X,80('-')) 
      WRITE (NOUT,30) 
      L=35  
      IF(KOUNT.LE.35) L=KOUNT
      K=11 
      J=25 
      GO TO 18 
31    IF (J.NE.25)  GO TO 32
      IF (KOUNT.LE.60)  GO TO 32
      IF (NUMBER.EQ.1)  WRITE(NOUT,20) ( ITITLE(I),I=1,80) 
      IF (NUMBER.EQ.2)  WRITE(NOUT,210)( ITITLE(I),I=1,80)
      WRITE (NOUT,988) 
      WRITE (NOUT,30)
      L=90 
      IF (KOUNT.LE.90) L=KOUNT
      K=61
      J=30 
      GO TO 18
   32 IF(NUMBER.EQ.2) GO TO 950
      NUMBER=2
      KOUNT=KOUNT2
      READ(NTAPE2,47) (TTH1(N),D(N),XINT1(N),IH(N),IK(N),IL(N),TTH2(N),
     1XINT2(N),XINT3(N),N=1,KOUNT)
   47 FORMAT(F5.0,2F10.5,3I5,3F5.0)
      GO TO 16
  950 IF (IREFL.EQ.NREFL) GO TO 970
      IREFL=NREFL-IREFL
      WRITE (NOUT,960) IREFL,UANGLE
  960 FORMAT ('  THE LAST ',I3,' REFLECTIONS ARE GREATER THAN ',F4.0,' D
     1EGREES 2THETA')
  970 REWIND NTAPE1
      REWIND NTAPE2
      WRITE (NOUT,1111) XMU,DENS,DENSC,XINTR,SC(5),NSG
1111  FORMAT (/'0LINEAR ABSORPTION COEFFICIENT = ',F8.2/
     1 '0INPUT DENSITY = ',F7.3/'0CALCULATED DENSITY = ',F7.3/
     2 '0I/I-CORUNDUM = ',F6.3/'0GAMMA = ',E15.7/
     3 '0SPACE GROUP = ',I4) 
      CLOSE(UNIT=NTAPE1)
      CLOSE(UNIT=NTAPE2)
      NTERMI=5
      NTERMO=6
 5510 WRITE (6,5511)
 5511 FORMAT (/' DO YOU WANT TO CREATE AN ASCII FILE SO THAT THE CALCULA
     *TED PATTERN'/,1X,'CAN BE ADDED TO THE DATABASE',
     *1X,'(Y OR [N]):  ',$)
      READ (NTERMI,5100) NCR,NQUES
 5100 FORMAT (Q,A)
      IF (NCR.EQ.0) NQUES='N'
      IF (NQUES.NE.'Y' .AND. NQUES.NE.'y' .AND. NQUES.NE.'N'
     *.AND. NQUES.NE.'n') GO TO 5510
      IF (NQUES.EQ.'Y' .OR. NQUES.EQ.'y') THEN
 5519 WRITE (NTERMO,5520)
 5520 FORMAT (/' YOU WILL NOW BE ASKED THE NAME OF A FILE'/
     1  5X,'PLEASE ENTER THE WORD "HELP" TO SEE THE LIST OF ALL'
     2  1X,'EXISTING *.ASC FILES'/
     3  5X,'PLEASE ENTER THE NAME OF THE FILE     ',$)
      READ (NTERMI,5000) FILEX
      IF(FILEX.EQ.'    ') FILEX='HELP'
5000  FORMAT (A18)
      IKEY=STR$UPCASE(FILEX,FILEX)
      IF (FILEX.EQ.'HELP') THEN
                          IKEY=LIB$SPAWN(' $ DIR *.ASC')
                          GO TO 5519
      END IF
      START=5.0
      FINISH=75.00
      STEP=0.02
      TIME=1.0
      NUMPT=3501
      IOUNIT=55
      OPEN(UNIT=IOUNIT,ERR=5519,RECL=80,STATUS='NEW',FILE=FILEX,
     1DEFAULTFILE='.ASC',CARRIAGECONTROL='LIST')
      WRITE(UNIT=IOUNIT,FMT=5002) TITLE,TITLE1
5002  FORMAT(A40,A39,1X)
      WRITE(UNIT=IOUNIT,FMT=5003) START,FINISH,STEP,TIME
5003  FORMAT(4F10.2)
      IF (SANGLE.EQ.5.00) THEN
      WRITE(UNIT=IOUNIT,FMT=5005) (Y(I),I=1,3501)
      ELSE
      WRITE(UNIT=IOUNIT,FMT=5005) (Y(I),I=251,3751)
      END IF
5005  FORMAT(10F8.0)
      CLOSE(UNIT=IOUNIT)
      WRITE(NTERMO,5006)
5006  FORMAT(//' THE USER SHOULD NOW RUN ENTERR'//)
      ELSE
      END IF
      RETURN 
      END
